' EVIEWS 6 BATCH FILE FOR Norwegian Aggregate Model (NAM)
' BY GUNNAR BRDSEN AND RAGNAR NYMOEN

	%RECZYF ="OFF"	 ' "ON" = recursive productivity equation. "OFF" = equation with feed-back from wage-price
	%RSHEND = "ON"   ' "ON" = RSH (short term interest rate) is endogenous in the model. Set to "OFF" to do interest rate shock 
	%PCKONKEND = "OFF" ' "ON" PCKONK is endogenous
'SET UP START AND END DATES	FOR WORKFILE AND END OF ESTIMATION
	%START = "1972Q1"	' FIRST OBSERVATION TO DUMMY
	%END =  "2035q4"    ' LAST OBSERVATION TO DUMMY
	%STOP = "2007q2"  	' last period in estimation period

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
%path = @runpath
cd %path

' CREATE A NEW WORKFILE
CREATE MOD Q %START %END


'*************************************************'

' IMPORT DATA FROM DATABASES

dbopen nam.in7
fetch *
close nam

SMPL @ALL
series ROILP=(SPOILUSD*SPUSD)/CPI
			
'*******************************************************************
' FORMULATE MODEL AND ESTIMATE THE EQUATIONS
'******************************************************************* 


' EXCHANGE RATE:
sample s_lr_cpival 1994q2 %STOP
smpl 1994q2 @last

series lr_cpival = @mean(log(cpival(-1)*pckonk(-1)/cpi(-1))+0.12*(rsh(-1)-@pcy(cpi(-1))-(rsw(-1)-@pcy(pckonk(-1)))),s_lr_cpival)
	smpl 1994q2 %STOP
	equation EQ_CPIVAL.LS dlog(cpival) = c(99)*(log(cpival(-1)*pckonk(-1)/cpi(-1))+0.12*(rsh(-1)-@pcy(cpi(-1))-(rsw(-1)-@pcy(pckonk(-1))))-lr_cpival) _
	+c(11)*D(RSH-RSW)*ITARG _
	+c(12)*Dlog(SPOILUSD(-1),2)+c(100)

' Import prices
    sample s_lr_pb 1990q1 %STOP
    smpl 1990q1 @last
	series lr_pb = @mean(log(pb(-1)/(ppikonk(-1)*cpival(-1)))+0.55*log(cpival(-1)*pckonk(-1)/cpi(-1)), s_lr_pb)
	SMPL 1990Q1 %STOP
	EQUATION EQ_PB.LS dlog(pb) = c(99)*(log(pb(-1)/(ppikonk(-1)*cpival(-1)))+ 0.55*log(cpival(-1)*pckonk(-1)/cpi(-1))- lr_pb) _
		+c(11)*dlog(cpival)+c(12)*dlog(ppikonk)+c(13)*cs1+c(14)*cs2+c(15)*cs3

'WAGE-PRICE-PRODUCTIVITY SYSTEM
	sample s_lr_wcfk 1978q1 %STOP
	sample s_lr_cpi 1978q1 %STOP
	sample s_lr_zyf 1978q1 %STOP
	sample s_lr_dzyf 1978q1 %STOP
	sample s_lr_dpb 1978q1 %STOP
	sample s_lr_dyf 1978q1 %STOP
	sample s_lr_cpiel 1978q1 %STOP
	sample s_lr_dwcfk 1978q1 %STOP
	smpl 1978q1 @LAST
	series lr_wcfk = @mean(LOG(WCFK(-1))-LOG(CPI(-2))-LOG(ZYF(-1))+0.10*LOG(UR2(-4))+0.03*(WBI1+SOS(-1)), s_lr_wcfk)
	SERIES LR_CPI = @MEAN(LOG(CPI(-3))-0.7*(LOG(WCFK(-1))-LOG(ZYF(-1)))-0.3*LOG(PB(-1)), S_LR_CPI)
	SERIES LR_ZYF = @MEAN(LOG(ZYF(-1))-0.52*LOG(WCFK(-3)/CPI(-3))-0.03*LOG(UR2(-2))-0.0029*@TREND, s_lr_zyf)
	SERIES M_DZYF =@mean(dlog(ZYF), s_lr_dzyf)
	SERIES M_DPB =@mean(DLOG(PB), s_lr_dpb)
	SERIES M_DYF =@mean(DLOG(YF), s_lr_dyf)
	SERIES M_DCPIEL =@mean(dlog(CPIEL), s_lr_cpiel)
	SERIES M_WC =@mean(DLOG(WCFK), s_lr_dwcfk)
	smpl 1979q2 %STOP 
	PARAM C(199) -0.07  C(299) -0.07 C(399) -0.4  C(112) 0.7
	
	SYSTEM SYS_WPPR

	' PRICE EQUATION   
	SYS_WPPR.APPEND DLOG(CPI) =  C(199)*(LOG(CPI(-3))-0.7*(LOG(WCFK(-1))-LOG(ZYF(-1)))-0.3*LOG(PB(-1))-LR_CPI) _
	+C(111)*(DLOG(ZYF)-M_DZYF)+C(112)*DLOG(CPI(-1))+ C(113)*DLOG(CPI(-2)) _
	+C(114)*(dlog(PB)-M_DPB)+C(115)*(DLOG(YF(-1))-M_DYF)+C(116)*(dlog(CPIEL)-M_DCPIEL) _
	+ C(117)*PDUMWK+C(118)*CS1+C(119)*CS2+C(120)*CS3+C(10)

	' WAGE EQUATION
	SYS_WPPR.APPEND DLOG(WCFK) = C(299)*(LOG(WCFK(-1))-LOG(CPI(-2))-LOG(ZYF(-1))+0.10*LOG(UR2(-4))+0.03*(WBI1+SOS(-1))-LR_WCFK) _
	+C(211)*(dlog(UR2(-1),1,1)+dlog(UR2(-3)))+ C(212)*d(T1FK)+C(213)*DLOG(CPI)+(1-c(213))*dlog(cpi(-1)) _
	+ c(214)*WKDUM + C(215)*CS1+C(216)*CS2+C(217)*CS3+c(218)*CS2*SOS(-1)+c(219)*CS3*SOS(-1) _
	+c(220)*FFORLENG+c(221)*WBI1*CS3+c(222)*WBI1*CS1+c(223)*WBI1*CS2+C(20)
   	
	' PRODUCTIVITY EQUATION
	SYS_WPPR.APPEND DLOG(ZYF) = C(399)*(LOG(ZYF(-1))-0.52*LOG(WCFK(-3)/CPI(-3))-0.03*LOG(UR2(-2))-0.0029*@TREND-LR_ZYF) _
	+C(311)*DLOG(WCFK/CPI) + C(312)*(dlog(ZYF(-1))+dlog(ZYF(-2)))+C(313)*PRDUM+ C(314)*CS3+C(30)			

	' ESTIMATE THE SYSTEM BY FIML
	SYS_WPPR.FIML(deriv=an)
	
' AGGREGATE DEMAND
	sample s_lr_yf 1978q1 %STOP
	smpl 1978q1 @last
	series lr_yf = @mean(log(yf(-3))-0.75*log(co(-1))+0.021*(rl(-1)-@pcy(cpi(-1))) _
	               -0.44*log(cpival(-1)*pckonk(-1)/cpi(-1))-0.16*LOG(K2(-1)/cpi(-1)), s_lr_yf)
	smpl 1978q1 %STOP
	param c(1) 0.9 c(2) -0.0057
	EQUATION EQ_YF.LS dlog(yf) = c(99)*(log(yf(-3))-0.75*log(co(-1))+0.021*(rl(-1)-@pcy(cpi(-1))) _
	               -0.44*log(cpival(-1)*pckonk(-1)/cpi(-1))-0.16*LOG(K2(-1)/cpi(-1))- lr_yf) _
 		+ c(11)*dlog(yf(-1)) + c(12)*dlog(co) _'+c(14)*YDUM2+c(14)*YDUM3+c(14)*YDUM4 _'+c(17)*YDUM5
		+ c(18)*cs1 + c(19)*cs2 + c(20)*cs3 + c(100)
	SMPL @ALL

	
' UNEMPLOYMENT

sample s_lr_ur2 1981q1 %STOP
	SMPL 1981Q1 @LAST
	series lr_ur2=@mean(log(UR2(-1))-UR2MEAN(-1), s_lr_ur2)
	smpl 1981q1 %STOP
	EQUATION EQ_UR2.LS DLOG(UR2) = C(99)*(log(UR2(-1))- UR2MEAN(-1)-lr_ur2) _
	+ C(11)*DLOG(WCFK(-2)/CPI(-2)) + C(12)*(0.01*(RL(-2)-@PCY(CPI(-2)))-DLOG(YF(-2),0,4)) _
	+ C(13)*DLOG(UR2(-1))+ C(14)*DLOG(UR2(-4))+ C(15)*DLOG(UR2(-5))+ C(16)*UDUM _
  	+ C(17)*CS1	+ C(18)*CS3 + C(100) 
	

' LOAN RATE - BOND RATE SYSTEM
SYSTEM SYS_RLRBO

	' LOAN RATE EQUATION
	sample s_lr_rl 1993q2 %STOP	 
	smpl 1993q2 @last
	series lr_rl = @mean(rl(-1) - 0.41*rbo(-1) - 0.76*rsh(-1), s_lr_rl)
	smpl 1993q2 %STOP  
	SYS_RLRBO.APPEND d(rl)  = c(199)*(rl(-1)- 0.41*rbo(-1) - 0.76*rsh(-1) - lr_rl) +c(111)*d(rsh) + c(112)*rldum + C(100)

	' BOND RATE EQUATION
	sample s_lr_rw 1993q2 %STOP	 
	smpl 1993q2 @last
	series lr_rbo = @mean(rbo(-1)-0.43*rsh - (1-0.43)*rw(-1), s_lr_rw)
	smpl 1993q2 %STOP 
	SYS_RLRBO.APPEND d(rbo) = c(299)*(rbo(-1)-0.43*rsh - (1-0.43)*rw(-1)-lr_rbo) + c(211)*d(rsh)+c(212)*d(rw)+ C(200)

	' ESTIMATE THE SYSTEM BY FIML
	SYS_RLRBO.FIML(deriv=an)
	smpl @all

' REAL CREDIT DEMAND
	sample s_lr_cr 2000q1 %STOP	 
	smpl 2000q1 @last
	series lr_k2_cpi = @mean(log(k2(-3)/cpi(-3))-2.65*log(yf(-4))+0.04*(rl(-4)-rbo(-4)), s_lr_cr)
	smpl 2000q1 %STOP 
	param c(99) -0.05
	EQUATION EQ_K2_CPI.LS dlog(k2/cpi) = c(99)*(log(k2(-3)/cpi(-3))-2.65*log(yf(-4))+0.04*(rl(-4)-rbo(-4))-lr_k2_cpi) _
	+c(11)*DLOG(YF(-2),0,2) _
	+C(12)*DLOG(WFK/CPI,2) _
	+c(100)
	smpl @all

' TECHNICAL EQUATION FOR MOVEMENTS IN CPIJAE
	SMPL @ALL
   SMPL 1995:1 %STOP 
param c(1) 0.4
  	EQUATION EQ_CPIJAE.LS log(cpijae/cpijae(-4)) =c(1)*(log(cpi/cpi(-4))-c(91)*log(cpiel/cpiel(-4)) _
	- c(92)*log(spoilusd/spoilusd(-3))) +(1-c(1))*log(CPIJAE(-1)/CPIJAE(-5)) _
	+ c(106)*JAEDUM+ c(100)
	SMPL @ALL

' TECHNICAL EQUATION FOR LABOUR FORCE SURVEY UNEMPLOYMENT RATE
	SMPL @ALL
	sample s_lr_uaku 1994q1 %STOP	 
	smpl 1994q1 @last
	SERIES LR_UAKU = @MEAN(UAKU - UR2, s_lr_uaku )
	SMPL 1991:1 %STOP 
	EQUATION EQ_UAKU.LS d(UAKU,0,4) d(UR2) d(UR2(-1)) d(UR2(-2)) d(ur2(-3)) (UAKU(-4) - UR2(-4)- LR_UAKU)
	             '       UAKUdum
	SMPL @ALL

' TECHNICAL EQUATION FOR OFFICIAL WAGE RATE
	SMPL @ALL
	SMPL 1991:1  %STOP '2006q1
	EQUATION EQ_WCF.LS WCF WCFK CS1 CS2 CS3 C
	SMPL @ALL

' Short-run interest rate
 	SMPL 1999q3 %STOP
	EQUATION EQ_RSH.LS RSH = C(100)+c(11)*(RSH(-1)) + c(12)*(@pcy(cpijae)- 2.5) _
		+ C(13)*d(CPIVAL*PCKONK/CPI,0,2) + C(14)*RSW +  C(15)*RSW(-2) _
	    +c(16)*UR2+c(17)*UR2(-1)+c(18)*UR2(-2)


			
' CREATE THE MODEL
	SYS_WPPR.MAKEMODEL(MOD_2SLS)
	MOD_2SLS.MERGE EQ_CPIVAL
	MOD_2SLS.MERGE EQ_YF
	MOD_2SLS.MERGE EQ_UR2
	MOD_2SLS.MERGE EQ_K2_CPI
	MOD_2SLS.MERGE SYS_RLRBO
	MOD_2SLS.MERGE EQ_CPIJAE
	MOD_2SLS.MERGE EQ_PB
	MOD_2SLS.MERGE EQ_UAKU
	MOD_2SLS.MERGE EQ_WCF
 	MOD_2SLS.MERGE EQ_RSH
	
		 	
'ADD IDENTITIES
	smpl @all
	SERIES INFJAE  = ((CPIJAE  - CPIJAE(-4))  / CPIJAE(-4))*100
	MOD_2SLS.APPEND @IDENTITY INFJAE  = ((CPIJAE  - CPIJAE(-4))  / CPIJAE(-4))*100
			
	SERIES INF  = ((CPI  - CPI(-4))  / CPI(-4))*100
	MOD_2SLS.APPEND @IDENTITY INF  = ((CPI  - CPI(-4))  / CPI(-4))*100
	
	SERIES YGR  = ((YF  - YF(-4))  / YF(-4))*100
	MOD_2SLS.APPEND @IDENTITY YGR  = ((YF  - YF(-4))  / YF(-4))*100
	
	SERIES DEPR  =( (CPIVAL  - CPIVAL(-4))  / CPIVAL(-4))*100
	MOD_2SLS.APPEND @IDENTITY DEPR  = ((CPIVAL  - CPIVAL(-4))  / CPIVAL(-4))*100
	
	SERIES PBGR  = ((PB  - PB(-4))  / PB(-4))*100
	MOD_2SLS.APPEND @IDENTITY PBGR  = ((PB  - PB(-4))  / PB(-4))*100
				
	SERIES WFK  = WCFK/(1+T1FK)
	MOD_2SLS.APPEND @IDENTITY WFK  = WCFK/(1+T1FK)

	SERIES WFREAL = WFK/CPI
	MOD_2SLS.APPEND @IDENTITY WFREAL = WFK/CPI

	SERIES WFRINF = 100*((WFREAL/WFREAL(-4))-1)	
	MOD_2SLS.APPEND @IDENTITY WFRINF = 100*((WFREAL/WFREAL(-4))-1)

	SERIES WCINF  = ((WCFK  / WCFK(-4))  - 1)*100
	MOD_2SLS.APPEND @IDENTITY WCINF  = ((WCFK  / WCFK(-4))  - 1)*100
	
	SERIES CR  = (K2  / CPI)
	MOD_2SLS.APPEND @IDENTITY CR  = (K2  / CPI)
	
	SERIES CRGR  = ((CR  / CR(-4))  - 1)*100
	MOD_2SLS.APPEND @IDENTITY CRGR  = ((CR  / CR(-4))  - 1)*100
	
	SERIES REXR  = (CPIVAL*PCKONK  / CPI)
	MOD_2SLS.APPEND @IDENTITY REXR  = ((CPIVAL*PCKONK)  / CPI)
			
 
SMPL @ALL	
	' 	IN-SAMPLE SIMULATION
	SMPL 2003Q1 2005Q4
			MOD_2SLS.SOLVEOPT(S=A, M=5000, R=1000, O=G, CU=F, B=0.95, CU=T) ' CU=T for pred interval with coeff uncert
			MOD_2SLS.SOLVE
  		   	MOD_2SLS.MAKEGRAPH(A, S=B, G=V) GRAPH_DYN INF UR2  WCINF YGR PBGR REXR RSH CRGR DEPR 
			graph_DYN.axis(l) grid
			show graph_DYN.align(3,1,1)
